// Alware Script Manager
// Copyright 2001 Allen Green
// Tribes 2:	Cyfin
// webpage:		http://t2.alware.com

deactivatePackage(Alware);
deactivatePackage(MonPack);

function ce(%file)
{
	compile(%file);
	exec(%file);
}


package Alware
{

	function AlwareEnabled()
	{
		return true;
	}

	function AlwareScriptsGui::onWake(%this)
	{
		Canvas.pushDialog(LaunchToolbarDlg);
		RefreshAlware();
		AlwareScriptsArray.setSelectedRow($Alware::LastID);
	}

	function AlwareScriptsGui::setKey( %this, %key )
	{
	}

	function AlwareScriptsArray::onSelect(%this, %id, %text)
	{
		call($Alware::Prev @ "DescClean");
		$Alware::Prev = $Alware::Array[%id];
		$Alware::LastID = %id;
		AlwareScriptActive.setActive(!$Alware::Status[$Alware::Prev]);
		AlwareScriptDeactive.setActive($Alware::Status[$Alware::Prev]);
		AlwareScriptEnabled.setValue(!$Alware::BanList[$Alware::Prev]);
		AlwareScriptDesc.setValue(call($Alware::Prev @ "Desc"));
		Canvas.repaint();
	}

	function RefreshAlware()
	{
		AlwareScriptsArray.clear();
		AlwareScriptsArray.addStyle(1, "", "","","","");
		AlwareScriptsArray.addStyle(2, "Alware/GreenCheck.png", "","","","");
		AlwareScriptsArray.addStyle(3, "", "Alware/RedX.png","","","");
		AlwareScriptsArray.addStyle(4, "Alware/GreenCheck.png", "Alware/RedX.png","","","");
		for(%i=0; %i <= $Alware::Count; %i++)
		{
			%text = call($Alware::Array[%i] @ "Name");
			if(%text !$= "")
			{
				AlwareScriptsArray.addRow(%i, %text);
				AlwareScriptsArray.setRowStyle(%i, !!$Alware::Status[$Alware::Array[%i]] + 1 + (2 * $Alware::BanList[$Alware::Array[%i]]));
			}
		}
		AlwareScriptActive.setActive(!$Alware::Status[$Alware::Prev]);
		AlwareScriptDeactive.setActive($Alware::Status[$Alware::Prev]);
		AlwareScriptEnabled.setValue(!$Alware::BanList[$Alware::Prev]);
		AlwareScriptDesc.setValue(call($Alware::Prev @ "Desc"));
		Canvas.repaint();
	}

	function Alware::EnableHit()
	{
		
		$Alware::BanList[$Alware::Prev] = !AlwareScriptEnabled.getValue();
		export("$Alware::BanList*", "Alware/BanList.cs", false);
		RefreshAlware();
		AlwareScriptsArray.setSelectedRow($Alware::LastID);
	}

	function AlwareScriptsGui::onSleep(%this)
	{
		Canvas.popDialog(LaunchToolbarDlg);
	}

	function OpenLaunchTabs(%gotoWarriorSetup)
	{
		parent::OpenLaunchTabs(%gotoWarriorSetup);
		compile("Alware/gui/Alware.gui");exec("Alware/gui/Alware.gui");
		if(!$Alware::Added) 
		{
			compile("Alware/gui/Alware.gui");exec("Alware/gui/Alware.gui");
			LaunchTabView.addLaunchTab( "ALWARE", AlwareScriptsGui );
			$Alware::Added = true;
		}
	}
 

function runAlware()
{
	%path = "Alware/GUI/*.gui";
   for( %file = findFirstFile( %path ); %file !$= ""; %file = findNextFile( %path ) )
   {
            compile( %file );
   }
	%path = "Alware/GUI/*.gui.dso";
   for( %file = findFirstFile( %path ); %file !$= ""; %file = findNextFile( %path ) )
   {
			%file = getSubStr( %file, 0, strlen(%file) -4 );
            exec( %file );
   }
	%path = "Alware/Scripts/*.cs";
   for( %file = findFirstFile( %path ); %file !$= ""; %file = findNextFile( %path ) )
   {
            compile( %file );
   }

   	%path = "Alware/Scripts/*.cs.dso";
   for( %file = findFirstFile( %path ); %file !$= ""; %file = findNextFile( %path ) )
   {
			%file = getSubStr( %file, 0, strlen(%file) -4 );
            exec( %file );
   }
}



}; //end Alware

    function AlwareStart()
    {
        $Alware::Prev = "";
		$Alware::Count = -1;
		$Alware::Added = false;
		$Alware::LastID = 0;
		activatePackage(AlwareFace);
        return 1;
    }

	package AlwareFace
	{
		function AlwareFaceStart()
		{
			return 1;
		}
	};


	function AlwareFaceName()
	{
		return "Alware Pak";
	}

	function AlwareFaceDesc()
	{
			return 
	"<JUST:CENTER><COLOR:FF0000>\n"
@	"<font:Arial:32> Alware Scripts Pak\n"
@	"<COLOR:66FF66><font:Univers condensed:22><JUST:LEFT>\n"
@	"Version:  <COLOR:FFFFFF>v1<COLOR:66FF66>\n"
@	"Description:\n"
@	"<JUST:CENTER><COLOR:FFFF66><font:arial:15>       Alware scripts pak is an interface for maintaining "
@	"configuring scripts. On the left hand side is a list of all the scripts. You may turn on and off a script by using"
@	" the \"Activate\" and \"Deactivate\" buttons at the top. The Green check means that script is Activated. Also above, "
@	" is the \"Enabled\" check box. When this is on, that script may be activated. When it is off, it prevents that script from "
@	" turning on until you decide to enable it. A red \"X\" means that script is Disabled and cannot activate.\n"
@	"<font:Univers:32>"
@	"<COLOR:FFFFFF>A"
@	"<COLOR:EEEEEE>L"
@	"<COLOR:DDDDDD>W"
@	"<COLOR:CCCCCC>A"
@	"<COLOR:BBBBBB>R"
@	"<COLOR:AAAAAA>E\n"
//@	"<font:Univers:22><a:PLAYER\tCYFIN>Cyfin@SSF</a>\n"
@	"<font:arial:25><COLOR:DDFDFF><a:WWWLINK\tt2.alware.com>Alware Scripts Homepage\n"
@	"<COLOR:BDDDDF><font:arial Bold:15>( http://T2.alware.com )</a>\n";
	}

	function DeactivateCurrent()
	{
		deactivatePackage($Alware::Prev);
		RefreshAlware();
		AlwareScriptsArray.setSelectedRow($Alware::LastID);

	}

	function ActivateCurrent()
	{
		activatePackage($Alware::Prev);
		RefreshAlware();
		AlwareScriptsArray.setSelectedRow($Alware::LastID);
	}

	function MonAct(%Package)
	{
	if(isPackage(%Package))
	{
		for(%i=0; %i <= $Alware::Count; %i++)
			if($Alware::Array[%i] $= %Package)
				%found = true;
		if(!%found)
		{
			%text = call(%Package @ "Name");
			if(%text !$= "")
				$Alware::Array[$Alware::Count++] = %Package;
		}

		if(!$Alware::BanList[%Package])
		{
    		return true;
		}else{
			error(%Package @ " Is Disabled And Cannot Run");
			return false;
		}
	}else{
		error("Not A Package");
		return false;
	}
	return false;
}

function MonDeact(%Package)
{
	$Alware::Status[%Package] = false;
}

package MonPack{

	function activatePackage(%Package)
	{
		if(MonAct(%Package))
		{
			parent::activatePackage(%Package);
			call(%Package @ "Start");
			$Alware::Status[%Package] = true;
			echo("Activateing: " @ %Package);
		}
	}

	function deactivatePackage(%Package)
	{
		MonDeact(%Package);
		echo("Deactivateing: " @ %Package);
		parent::deactivatePackage(%Package);
	}


}; //end MonScripts


activatepackage(MonPack);
activatepackage(Alware);
schedule(1000, 0, runAlware);


